<template>
  <div class="app-container">
    <div style="">
      <Titlename title="录入举一反三页面"></Titlename>
      <div class="whole-form">
        <el-form
          :model="ruleForm"
          :rules="rules"
          ref="ruleForm"
          label-width="150px"
          class="demo-ruleForm"
          style="margin: 0 14% 0 16%">
          <el-row>
            <el-col :span="9">
              <el-form-item label="检查时间" prop="check_date">
                <el-date-picker
                  v-model="ruleForm.check_date"
                  type="date"
                  value-format="yyyy-MM-dd"
                  placeholder="选择日期"
                  style="width: 100%">
                </el-date-picker>
              </el-form-item>
            </el-col>
             <el-col :span="9">
              <el-form-item label="检查类别" prop="checktype">
                  <el-select v-model="ruleForm.checktype" placeholder="请选择"  style="width: 100%">
                      <el-option
                          v-for="item in JCLBList"
                          :key="item.value"
                          :label="item.value"
                          :value="item.value">
                      </el-option>
                  </el-select>
              </el-form-item>
            </el-col>
          </el-row>
          <el-row>
            <el-col :span="9" >
              <el-form-item label="检查单位" prop="check_main_branch">
                  <el-input v-model="ruleForm.check_main_branch" style="width:100%"></el-input>
<!--                  <el-select v-model="ruleForm.check_main_branch" placeholder="请选择"  @change="changeJCDW"  style="width: 100%">-->
<!--                      <el-option-->
<!--                          v-for="item in JCDWList"-->
<!--                          :key="item.label"-->
<!--                          :label="item.label"-->
<!--                          :value="item.label"-->
<!--                      >-->
<!--                      </el-option>-->
<!--                  </el-select>-->
              </el-form-item>
            </el-col>
          </el-row>


            <el-row style="margin-bottom: 20px">
                <el-col :span="9">
                    <el-button type="primary" class="btns" @click="addDanger()">新增</el-button>
                </el-col>
            </el-row>

                <el-table :data="tableData" style="width: 100%">
                    <el-table-column type="index" width="55" align="center" label="序号"></el-table-column>
                    <el-table-column prop="address"  align="center" label="隐患地点"></el-table-column>
                    <el-table-column prop="ht_content"  align="center" label="隐患内容"></el-table-column>
                    <el-table-column prop="ht_typesub"  align="center" label="隐患类别"></el-table-column>
                    <el-table-column prop="ht_level"  align="center" label="隐患级别"></el-table-column>
                    <el-table-column prop="time" label="操作" align="center" width="140">
                        <template slot-scope="scope">
                            <div style="display: flex;align-items: center;flex-direction: row;">
                                <el-button size="mini" @click="editDanger(scope.row, scope.$index)">
                                    编辑
                                </el-button>
                                <el-button size="mini" @click="deleteDanger(scope.row, scope.$index)">
                                    删除
                                </el-button>
                            </div>
                        </template>
                    </el-table-column>
                </el-table>
          <el-row style="margin-top: 20px">
            <el-col :span="22">
              <el-form-item style="text-align: center">
                <el-button type="primary" class="btns" @click="submitForm('ruleForm')">
                    保存
                </el-button>
                <el-button @click="closeShow">关闭</el-button>
              </el-form-item>
            </el-col>
          </el-row>
        </el-form>
      </div>
    </div>

      <el-dialog
          :title="title"
          :visible.sync="dialogVisible"
          :close-on-click-modal="false"
          width="40%">
          <el-form ref="form" :rules="dangerRules" :model="dangerForm" label-width="100px">
              <el-row>
                  <el-col :span="9">
                      <el-form-item label="隐患地点" prop="address">
                          <el-input v-model="dangerForm.address" rows="3" type="textarea" class="multiline"></el-input>
                      </el-form-item>
                  </el-col>
                  <el-col :span="9" :offset="4">
                      <el-form-item label="隐患内容" prop="ht_content">
                          <el-input v-model="dangerForm.ht_content" rows="3" type="textarea" class="multiline"></el-input>
                      </el-form-item>
                  </el-col>
              </el-row>
              <el-row>

                 <el-col :span="9">
                      <el-form-item label="隐患类别" prop="ht_typesub">
                          <el-select v-model="dangerForm.ht_typesub" placeholder="请选择">
                              <el-option
                                  v-for="item in YHLXList"
                                  :key="item.value"
                                  :label="item.value"
                                  :value="item.value">
                              </el-option>
                          </el-select>
                      </el-form-item>
                  </el-col>
                  <el-col :span="9" :offset="4">
                      <el-form-item label="隐患级别" prop="ht_level">
                          <el-select v-model="dangerForm.ht_level" placeholder="请选择">
                              <el-option
                                  v-for="item in YHJBList"
                                  :key="item.value"
                                  :label="item.label"
                                  :value="item.value">
                              </el-option>
                          </el-select>
                      </el-form-item>
                  </el-col>
              </el-row>
              <el-row>
                  <el-col :span="22">
                      <el-form-item style="text-align: center">
                          <el-button type="primary" class="btns" @click="submitDanger('form')">
                              保存
                          </el-button>
                          <el-button @click="dialogVisible=false">关闭</el-button>
                      </el-form-item>
                  </el-col>
              </el-row>
          </el-form>
      </el-dialog>

  </div>
</template>

<script>
import Titlename from "../../components/Titlename/index.vue";

import {initJCBM ,initYHLX,initJCLB,initYHJB,initReformStatus} from "@/api/sgyhpczl/initSelect";
import {saveDanger,initDangerRebound,getDangerInfo,editDanger} from '@/api/sgyhpczl/hiddenDangerRegistration'
import { save } from '@/api/sgyhpczl/oneFromanotherN'

import {deepClone} from '@/utils'

export default {
  components: { Titlename },
  name: "hiddenDangerList",
  data() {
    return {
        id:'',
        rowIndex:-1,
        dangerList:[],
        dangerForm:{},
        dangerRules:{
            address: [{ required: true, message: '不能为空', trigger: 'blur' },],
            ht_content: [{ required: true, message: '不能为空', trigger: 'blur' },],
            ht_typesub: [{ required: true, message: '不能为空', trigger: 'blur' },],
            ht_level: [{ required: true, message: '不能为空', trigger: 'blur' },],
        },
        title:'新增',
        dialogVisible:false,
        JCLBList:[],
        YHLXList:[],
        YHJBList:[],
        ruleForm: {},
        rules: {
           check_date: [{ required: true, message: '不能为空', trigger: 'blur' },],
           check_main_branch: [{ required: true, message: '不能为空', trigger: 'change' },],
           checktype: [{ required: true, message: '不能为空', trigger: 'blur' },],
        },
        tableData: [],
    };
  },
    mounted(){
        this.initJCLB()
        this.initYHJB()
        this.initYHLX()
    },
  methods: {
      submitDanger(formName){
          this.$refs[formName].validate((valid) => {
              if (valid) {
                  if(this.title=='新增'){
                      this.tableData.push(this.dangerForm)
                  }else {
                      var arr = this.tableData;
                      arr.splice(this.rowIndex, 1, this.dangerForm);
                      this.tableData = arr;
                  }
                  this.dialogVisible=false

              } else {
                  console.log("error submit!!");
                  return false;
              }
          });
      },
      deleteDanger(row, index) {
          this.$confirm('确认删除吗', '提示', {
              confirmButtonText: '确认',
              cancelButtonText: '取消',
              type: 'warning'
          })
              .then(() => {
                  var arr = deepClone(this.tableData);
                  var brr = [];
                  for (var i = 0; i < arr.length; i++) {
                      if (i == index) {
                      } else {
                          brr.push(arr[i]);
                      }
                  }
                  this.tableData = deepClone(brr);
                  //this.tableData.splice(index)

              })
              .catch(error => {
              });


      },
      editDanger(row, index) {
          this.dangerForm = deepClone(row);
          this.rowIndex = index;
          this.dialogVisible = true;
          this.title = '编辑';
      },

      addDanger(){
          this.dangerForm={}
          this.title="新增"
          this.dialogVisible=true
      },
      changeWxy(e){
          for(var i=0;i<this.dangerList.length;i++){
              if(e==this.dangerList[i].id){
                  this.dangerForm.DTRisk_level=this.dangerList[i].mriskLevel
                  this.dangerForm.dangerousSource=this.dangerList[i].mriskPoint
              }
          }
      },
      initReformStatus(){
          initReformStatus().then(res=>{
              if (res.data.ok==1){
                  this.statusList=res.data.data
              } else{
                  this.$message({type:'error', message:res.data.msg, duration:3000})
              }
          })
      },
      changeJCDW(val){
          initJCBM(val).then(res=>{
              if (res.data.ok==1){
                  this.JCBMList=res.data.data
              } else{
                  this.$message({type:'error', message:res.data.msg, duration:3000})
              }
          })
      },
      initYHLX(){
          initYHLX().then(res=>{
              if (res.data.ok==1){
                  this.YHLXList=res.data.data
              } else{
                  this.$message({type:'error', message:res.data.msg, duration:3000})
              }
          })
      },
      initYHJB(){
          initYHJB().then(res=>{
              if (res.data.ok==1){
                  this.YHJBList=res.data.data
              } else{
                  this.$message({type:'error', message:res.data.msg, duration:3000})
              }
          })
      },
      initJCLB(){
          initJCLB().then(res=>{
              if (res.data.ok==1){
                  this.JCLBList=res.data.data
              } else{
                  this.$message({type:'error', message:res.data.msg, duration:3000})
              }
          })
      },

      closeShow(){
          this.$router.push({
              path:"/oneFromanotherN"
          })
      },
    submitForm(formName) {
      this.$refs[formName].validate((valid) => {
        if (valid) {
            if(this.tableData==null || this.tableData.length==0){
                this.$message({type:'error', message:"请添加隐患", duration:2000})
            }
            this.ruleForm.items=this.tableData
            save(this.ruleForm).then(res=>{
                if (res.data.ok==1){
                    this.$message({type:'success', message:"新增成功", duration:3000})
                    this.$router.push({
                        path:"/oneFromanotherN"
                    })
                }else {
                    this.$message({type:'error', message:res.data.msg, duration:3000})
                }
            })

        } else {
          console.log("error submit!!");
          return false;
        }
      });
    },
  },
};
</script>

<style scoped>
.app-container {
  padding: 20px;
  height: 850px;
  overflow-y: auto;
}

.app-container /deep/ .box {
  padding-top: 0;
}

/* /deep/ .multiline .el-input__inner {
  height: 62px;
} */
 .btns{
        background-color: #034ea2;
        border: 1px solid #034ea2;
    }
</style>
